<?
// GADMIN 4 RaidenFTPD [V.1.5] [3-23-2003]
// This script enables "GADMIN" support in RaidenFTPD.
// With this script, you can create Groups with a specified number of "slots."
// The number of slots determines how many users can be added to that Group.
// Once the slots are full, no more users are added until an existing member is deleted or an Admin
// increase the Group's allocated slots.
// The GADMIN data is stored in a file in your Raiden dir called GADMIN.DATA. You can edit this file
// directly to make GADMIN changes. USE ONLY NOTEPAD TO CHANGE DATA!
// The format of each line in the file is -
// Groupname : # Of Ratio Slots : # Of Leech Slots : Ratio Slots Used : Leech Slots Used : Ratio : User1*R : User2*L : User3*R etc...
// The *R and *L are used to denote whether the User is using a Ratio or Leech slot.

// This line needs to be added to your .FTPD file -
// onSiteCmd=exec://C:\Path\to\CLI\PHP.exe GAdmin.php %@ %$ %g %!

// Also, you will want to disable the ADDUSER, DELUSER, and CHRATIO command for SU level users. Do this by adding this line -
// EXCEPT_SITE_CMD_S=adduser,deluser,chratio

// Root level users can execute any GADMIN command, but SU users can only use GADMIN commands that affect
// their group - ADDUSER and DELUSER and STATS and PURGE



##### SET THE FIVE VARIABLES BELOW #####
// Some variables...
// Set this to your RaidenFTPD directory.
// For example = "C:/Program Files/RaidenFTPD/"
$Raidenroot = "C:/Program Files/RaidenFTPD/";

// IP/DNS of server. Can be numeric or DNS name. Keep quotes around this value.
$Server = "127.0.0.1";

// Port that Raiden runs on.
$Port = 15551;

// User to log into Raiden as - this must be Root level account.
$User = "WebBot";

// Password for $User above to log into Raiden.
$Pass = "webbotpass";



####### CONFIG DONE - DO NOT EDIT BELOW #######
#######           BEGIN CODE            #######

// GADMIN Data file.
$Data = $Raidenroot."GADMIN.DATA";

// Do NOT change this value.
$Outputdir = $Raidenroot . "Output/";

// Read in values from Raiden.
$GCID = $argv[1];
$Rlvl = $argv[2];
$Rgroup = $argv[3];
$CMD = strtolower($argv[4]);

// See if CMD is GADMIN
if ($CMD == "gadmin")
{
   // Start output buffering and redirect any output to the "Output" function...
   ob_start("Output");

   $Action = strtolower($argv[5]);
   if (($Action != "grpadd")&&($Action != "grpdel")&&($Action != "chslots")&&($Action != "adduser")&&($Action != "deluser")&&($Action != "list")&&($Action != "stats")&&($Action != "chratio")&&($Action != "help")&&($Action != "purge"))
   {
      echo "Invalid GADMIN command. Try again.";
      exit;
   }
   if ((($Action == "grpadd")||($Action == "grpdel")||($Action == "chslots")||($Action == "list")||($Action == "chratio")) && ($Rlvl > 0))
   {
      echo "No access to this command - ROOT level ONLY.";
      exit;
   }
   if (($Action == "adduser"||"deluser"||"stats"||"help"||"purge") && ($Rlvl > 1))
   {
      echo "No access to this command - Group Admins and ROOT ONLY.";
      exit;
   }
   
   // Have checked we have a valid command - open GADMIN data file.
   $DataFP = fopen($Data, "a+");
   rewind($DataFP);
   // $Action = HELP
   if ($Action == "help")
   {
      echo "\n";
      echo "[..:GADMiN FOR RAiDENFTPD:..]\n";
      echo "General HELP section. Valid GADMiN Commands are :\n";
      echo "===========\n";
      echo "[    LIST :\n";
      echo "[  GRPADD : [More..]\n";
      echo "[  GRPDEL : [More..]\n";
      echo "[ CHSLOTS : [More..]\n";
      echo "[ CHRATIO : [More..]\n";
      echo "[   STATS : [More..]\n";
      echo "[ ADDUSER : [More..]\n";
      echo "[ DELUSER : [More..]\n";
      echo "[   PURGE : [More..]\n";
      echo "===========\n";
      echo "If the command says [More..] after it, then you can get more help.\n";
      echo "Do this by sending SITE GADMIN COMMAND HELP to the server.\n";
      echo "For help with ADDUSER, send SITE GADMIN ADDUSER HELP\n";
      fclose($DataFP);
      exit;
   }
   // $Action == LIST
   if ($Action == "list")
   {
      $String = fread($DataFP, filesize($Data));
      $Lines = explode("\n", $String);
      $Numgrp = count($Lines);
      for ($i = 0; $i < $Numgrp; $i++)
      {
         $Tmp = explode(":", $Lines[$i]);
         $Group[$i] = $Tmp[0];
         $Rslot[$i] = $Tmp[1];
         $Lslot[$i] = $Tmp[2];
         $Rused[$i] = $Tmp[3];
         $Lused[$i] = $Tmp[4];
         $Ratio[$i] = $Tmp[5];
      }
      echo "\n";
      echo "[..:GADMiN FOR RAiDENFTPD:..]\n";
      echo "=================================================================\n";
      echo "[..:Group Name:..][#Leech][Used Leech][#Ratio][Used Ratio][Ratio]\n";
      echo "=================================================================\n";
      for ($i = 0; $i+1 < $Numgrp; $i++)
      {
         echo "[ ".str_pad($Group[$i], 14)." ][ ".str_pad($Lslot[$i], 4)." ][ ".str_pad($Lused[$i], 8)." ][ ".str_pad($Rslot[$i], 4)." ][ ".str_pad($Rused[$i], 8)." ][ ".str_pad($Ratio[$i], 4)."]\n";
      }
      fclose($DataFP);
      exit;
   }
   // $Action = GRPADD
   if ($Action == "grpadd")
   {
      $Gname = $argv[6];
      $Rslots = $argv[7];
      $Lslots = $argv[8];
      $Ratio = $argv[9];
      // Check to see if HELP requested...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT to add a group to GADMIN.\n";
         echo "The syntax for GRPADD is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN GRPADD [Groupname] [# Of Ratio Slots] [# Of Leech Slots] [Group Ratio]\n";
         fclose($DataFP);
         exit;
      }
      if (($Rslots < 0) || ($Rslots > 100) || (!isset($Rslots)) || ($Ratio < 0) || ($Ratio > 100) || (!isset($Ratio)) || ($Lslots < 0) || ($Lslots > 100) || (!isset($Lslots)))
      {
         echo "Invalid number of SLOTS or RATIO.\n";
         echo "Must be a value between 0 and 100.";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." already exists.\n";
         echo "Use GRPDEL first or just ADDUSER.";
         fclose($DataFP);
         exit;
      }
      fseek($DataFP, 0, SEEK_END);
      $String = $Gname.":".$Rslots.":".$Lslots.":0:0:".$Ratio."\n";
      fputs($DataFP, $String);
      echo "Group ".$Gname." added successfully.";
      fclose($DataFP);
      exit;
   }
   // $Action = GRPDEL
   if ($Action == "grpdel")
   {
      $Gname = $argv[6];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT to delete a group from GADMIN.\n";
         echo "The syntax for GRPDEL is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN GRPDEL [Groupname]\n";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!isset($Gname))
      {
         echo "You must enter a Groupname to delete.";
         fclose($DataFP);
         exit;
      }
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist.\nYou cannot delete it.";
         fclose($DataFP);
         exit;
      }
      $Pos = strpos($String, $Gname.":");
      $String1 = substr($String, 0, $Pos);
      $String2 = strstr($String, $Gname.":");
      $Split = explode("\n", $String2, 2);
      $String2 = $Split[1];
      $String = $String1.$String2;
      ftruncate($DataFP, 0);
      fputs($DataFP, $String);
      fclose($DataFP);
      echo "Success! Group ".$Gname." has been deleted.";
      exit;
   }
   // $Action = CHSLOTS
   if ($Action == "chslots")
   {
      $Gname = $argv[6];
      $Type = strtolower($argv[7]);
      $Newslots = $argv[8];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT to change the Leech or Ratio slots for a Group.\n";
         echo "The syntax for CHSLOTS is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN CHSLOTS [Groupname] [Ratio/Leech] [# Of Slots]\n";
         fclose($DataFP);
         exit;
      }
      if (($Newslots < 0) || ($Newslots > 100) || (!isset($Newslots)) )
      {
         echo "Invalid number of SLOTS.\n";
         echo "Must be a value between 0 and 100";
         fclose($DataFP);
         exit;
      }
      if (($Type != "ratio") && ($Type != "leech"))
      {
         echo "Invalid SLOT TYPE.\n";
         echo "Must be either \"RATIO\" or \"LEECH\".";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist.\n";
         echo "You must use GRPADD first.";
         fclose($DataFP);
         exit;
      }
      $Pos = strpos($String, $Gname.":");
      $String1 = substr($String, 0, $Pos);
      $String2 = strstr($String, $Gname.":");
      $Slot = explode(":", $String2, 5);
      if ($Type == "ratio")
      {
         $Slot[1] = $Newslots;
      }
      else
      {
         $Slot[2] = $Newslots;
      }
      $String2 = implode(":", $Slot);
      $String = $String1.$String2;
      ftruncate($DataFP, 0);
      fputs($DataFP, $String);
      fclose($DataFP);
      $Type = strtoupper($Type);
      echo "Success! ".$Type." Slots changed to ".$Newslots." for Group ".$Gname;
      exit;
   }
   // $Action = CHRATIO
   if ($Action == "chratio")
   {
      $Gname = $argv[6];
      $Newratio = $argv[7];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT to change the Ratio for a Group.\n";
         echo "The syntax for CHRATIO is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN CHRATIO [Groupname] [Ratio]\n";
         fclose($DataFP);
         exit;
      }
      if (($Newratio < 0) || ($Newratio > 100) || (!isset($Newratio)))
      {
         echo "Invalid new RATIO.\n";
         echo "Must be a value between 0 and 100";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist.\n";
         echo "You must use GRPADD first.";
         fclose($DataFP);
         exit;
      }
      $Pos = strpos($String, $Gname.":");
      $String1 = substr($String, 0, $Pos);
      $String2 = strstr($String, $Gname.":");
      $Lines = explode("\n", $String2);
      $Slot = explode(":", $Lines[0]);
      $Slot[5] = $Newratio;
      $Lines[0] = implode(":", $Slot);
      $String2 = implode("\n", $Lines);
      $String = $String1.$String2;
      ftruncate($DataFP, 0);
      fputs($DataFP, $String);
      fclose($DataFP);
      echo "Success! RATIO changed to ".$Newratio." for Group ".$Gname;
      exit;
   }
   // $Action = STATS
   if ($Action == "stats")
   {
      $Gname = $argv[6];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT or a GAdmin to view the stats for a Group.\n";
         echo "The syntax for STATS is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN STATS [Groupname]\n";
         fclose($DataFP);
         exit;
      }
      if (($Gname != $Rgroup) && ($Rlvl != 0))
      {
         echo "Access Denied - You can only view STATS for your own Group.";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist.\n";
         echo "No STATS for this group.";
         fclose($DataFP);
         exit;
      }
      $String1 = strstr($String, $Gname.":");
      $Split = explode("\n", $String1, 2);
      $Slot = explode(":", $Split[0]);
      echo "STATS for Group : ".$Gname."\n";
      echo "=========================\n";
      echo "[             Groupname : ".$Slot[0]."\n";
      echo "[ Leech Slots Allocated : ".$Slot[2]."\n";
      echo "[      Leech Slots Used : ".$Slot[4]."\n";
      echo "[ Ratio Slots Allocated : ".$Slot[1]."\n";
      echo "[      Ratio Slots Used : ".$Slot[3]."\n";
      echo "[           Group Ratio : ".$Slot[5]."\n";
      echo "=========================\n";
      for ($i = 6; isset($Slot[$i]); $i++)
      {
         if (strstr($Slot[$i], "*R"))
         {
            $Pos = strpos($Slot[$i], "*R");
            $Name = substr_replace($Slot[$i], "", $Pos);
            echo "Member".($i - 5)." : RATIO : ".$Name."\n";
         }
         else
         {
            $Pos = strpos($Slot[$i], "*L");
            $Name = substr_replace($Slot[$i], "", $Pos);
            echo "Member".($i - 5)." : LEECH : ".$Name."\n";
         }
      }
      fclose($DataFP);
      exit;
   }
   // $Action = ADDUSER
   if ($Action == "adduser")
   {
      $Gname = $argv[6];
      $Type = strtolower($argv[7]);
      $Nuser = $argv[8];
      $Npass = $argv[9];
      $NIP = $argv[10];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT or a GAdmin to add a user to a Group.\n";
         echo "The syntax for ADDUSER is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN ADDUSER [Groupname] [Ratio/Leech] [Username] [Password] [IP]\n";
         fclose($DataFP);
         exit;
      }
      if ((!isset($Gname)) || (!isset($Type)) || (!isset($Nuser)) || (!isset($Npass)) || (!isset($NIP)))
      {
         echo "Invalid number of parameters.\n";
         echo "Format is ADDUSER [Group] [Ratio/Leech] [Username] [Pass] [IP]";
         fclose($DataFP);
         exit;
      }
      if (($Rlvl == 1)&&($Rgroup != $Gname))
      {
         echo "Access Denied. Group Admins can only ADDUSER to their OWN group.";
         fclose($DataFP);
         exit;
      }
      if (($Type != "ratio") && ($Type != "leech"))
      {
         echo "Invalid account TYPE.\nMust be \"RATIO\" or \"LEECH\".";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist in GADMIN.\n";
         echo "Root must add the group to GADMIN first.";
         fclose($DataFP);
         exit;
      }
      // Get number of slots assigned to Group.
      $Totslots = getTotSlots($DataFP, $Data, $Gname, $Type);
      // Get number of Used slots.
      $Usedslots = getUsedSlots($DataFP, $Data, $Gname, $Type);
      // Check to see if there is a slot available.
      if ($Usedslots >= $Totslots)
      {
         echo "Sorry, ".strtoupper($Type)." Slots for Group ".$Gname." are full.\n";
         echo "Use DELUSER or Root can increase slots with CHSLOTS command.";
         fclose($DataFP);
         exit;
      }
      // Get Ratio for the User.
      if ($Type == "ratio")
      {
         $Ratio = getRatio($DataFP, $Data, $Gname);
      }
      else
      {
         $Ratio = 0;
      }
      $FTP = ftp_connect("$Server", $Port, 10);
      $Login = ftp_login($FTP, $User, $Pass);
      $Testuser = "user ".$Nuser;
      $Adduser = "adduser ".$Nuser." ".$Npass." ".$Gname;
      $Addip = "addip ".$Nuser."@".$NIP;
      $Chratio = "chratio ".$Nuser." ".$Ratio;
      $Chlvl = "chlvl ".$Nuser." 2";
      // Check to see if user exists in Raiden
      @ $Test = ftp_site($FTP, "$Testuser");
      if ($Test)
      {
         echo "User already exists on FTP Server. Use another name.";
         fclose($DataFP);
         exit;
      }
      delay();
      ftp_site($FTP, $Adduser);
      delay();
      ftp_site($FTP, $Addip);
      delay();
      ftp_site($FTP, $Chratio);
      delay();
      $Res = ftp_site($FTP, $Chlvl);
      delay();
      if (!$Res)
      {
         echo "There was an error processing - Please try again.";
         fclose($DataFP);
         exit;
      }
      addToFile($DataFP, $Data, $Gname, $Nuser, $Type);
      incUsedSlots($DataFP, $Data, $Gname, $Type);
      fclose($DataFP);
      echo "\n";
      echo "Success - User added. Details below.\n";
      echo "=========\n";
      echo "[ Group : ".$Gname."\n";
      echo "[  User : ".$Nuser."\n";
      echo "[  Pass : ".$Npass."\n";
      echo "[ Ratio : ".$Ratio."\n";
      echo "[    IP : ".$NIP."\n";
      echo "=========\n";
      exit;
   }
   // $Action = DELUSER
   if ($Action == "deluser")
   {
      $Gname = $argv[6];
      $Nuser = $argv[7];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT or a GAdmin to delete a user from a Group.\n";
         echo "The syntax for DELUSER is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN DELUSER [Groupname] [Username]\n";
         fclose($DataFP);
         exit;
      }
      if (($Rlvl == 1)&&($Rgroup != $Gname))
      {
         echo "Access Denied. Group Admins can only DELUSER of their OWN group.";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      if (!strstr($String, $Gname.":"))
      {
         echo "Group ".$Gname." does not exist in GADMIN.\nYou cannot delete a user from it.";
         fclose($DataFP);
         exit;
      }
      $Grpmembercheck = strstr($String, $Gname.":");
      $Grpline = explode("\n", $Grpmembercheck, 2);
      if (!strstr($Grpline[0], $Nuser."*"))
      {
         echo "User ".$Nuser." does not exist in GADMIN or is not in Group ".$Gname."\n";
         echo "You cannot delete it.";
         fclose($DataFP);
         exit;
      }
      if (strstr($String, $Nuser."*R"))
      {
         $Dname = $Nuser."*R";
         $Type = "R";
      }
      else
      {
         $Dname = $Nuser."*L";
         $Type = "L";
      }
      $Deluser = "deluser ".$Nuser;
      $FTP = ftp_connect("$Server", $Port, 10);
      $Login = ftp_login($FTP, $User, $Pass);
      delay();
      $Res = ftp_site($FTP, $Deluser);
      delay();
      if (!$Res)
      {
         echo "Sorry, could not delete - User is not on the FTP server.";
         fclose($DataFP);
         exit;
      }
      delFromFile($DataFP, $Data, $Gname, $Dname);
      decUsedSlots($DataFP, $Data, $Gname, $Type);
      echo "Success! User ".$Nuser." has been deleted from Group ".$Gname;
      fclose($DataFP);
      exit;
   }
   // PURGE function - deletes user from GAdmin, but not FTP.
   if ($Action == "purge")
   {
      $Gname = $argv[6];
      $Deluser = $argv[7];
      // Check for HELP request...
      if (strtolower($Gname) == "help")
      {
         echo "\n";
         echo "[GADMIN HELP]\n";
         echo "This command is used by ROOT or a GAdmin to PURGE a user from GAdmin.\n";
         echo "This should only be used if the user is listed in GAdmin, but is not on the FTP server.\n";
         echo "PURGE is used when DELUSER returns the error - User is not on the FTP. Cannot Delete.\n";
         echo "The syntax for PURGE is...WITHOUT THE BRACKETS...\n";
         echo "SITE GADMIN PURGE [Groupname] [Username]\n";
         fclose($DataFP);
         exit;
      }
      if (($Rlvl == 1)&&($Rgroup != $Gname))
      {
         echo "Access Denied. Group Admins can only PURGE users from their OWN group.";
         fclose($DataFP);
         exit;
      }
      $String = fread($DataFP, filesize($Data));
      $Grpmembercheck = strstr($String, $Gname.":");
      $Grpline = explode("\n", $Grpmembercheck, 2);
      if (!strstr($Grpline[0], $Deluser."*"))
      {
         echo "User ".$Nuser." does not exist in GADMIN or is not in Group ".$Gname."\nYou cannot delete it.";
         fclose($DataFP);
         exit;
      }
      if (strstr($String, $Deluser."*R"))
      {
         $Dname = $Deluser."*R";
         $Type = "R";
      }
      else
      {
         $Dname = $Deluser."*L";
         $Type = "L";
      }
      delFromFile($DataFP, $Data, $Gname, $Dname);
      decUsedSlots($DataFP, $Data, $Gname, $Type);
      echo "Success! User ".$Deluser." has been purged from Group ".$Gname." in the GADMIN data file.";
      fclose($DataFP);
      exit;
   }
}
exit;

// GetRatio from GADMIN
function getRatio($FP, $File, $Group)
{
   rewind($FP);
   $String = fread($FP, filesize($File));
   $String1 = strstr($String, $Group.":");
   $Lines = explode("\n", $String1, 2);
   $Split = explode(":", $Lines[0], 7);
   $Ratio = $Split[5];
   return $Ratio;
}
// Get Total Slots available from GADMIN
function getTotSlots($FP, $File, $Group, $Tipe)
{
   rewind($FP);
   $String = fread($FP, filesize($File));
   $String1 = strstr($String, $Group.":");
   $Lines = explode("\n", $String1, 2);
   $Split = explode(":", $Lines[0], 6);
   if ($Tipe == "ratio")
   {
      $Slots = $Split[1];
   }
   else
   {
      $Slots = $Split[2];
   }
   return $Slots;
}
// Get Used Slots from GADMIN
function getUsedSlots($FP, $File, $Group, $Tipe)
{
   rewind($FP);
   $String = fread($FP, filesize($File));
   $String1 = strstr($String, $Group.":");
   $Lines = explode("\n", $String1, 2);
   $Split = explode(":", $Lines[0], 6);
   if ($Tipe == "ratio")
   {
      $Used = $Split[3];
   }
   else
   {
      $Used = $Split[4];
   }
   return $Used;
}
// INCREMENT USED SLOTS
function incUsedSlots($FP, $File, $Group, $Tipe)
{
   rewind($FP);
   $String = fread($FP, 10000);
   $Pos = strpos($String, $Group.":");
   $String1 = substr($String, 0, $Pos);
   $String2 = strstr($String, $Group.":");
   $Lines = explode("\n", $String2);
   $Split = explode(":", $Lines[0]);
   if ($Tipe == "ratio")
   {
      $Split[3] = $Split[3] + 1;
   }
   else
   {
      $Split[4] = $Split[4] + 1;
   }
   $Lines[0] = implode(":", $Split);
   $String2 = implode("\n", $Lines);
   $String = $String1.$String2;
   ftruncate($FP, 0);
   fputs($FP, $String);
}
// DECREMENT USED SLOTS
function decUsedSlots($FP, $File, $Group, $Tipe)
{
   rewind($FP);
   $String = fread($FP, 10000);
   $Pos = strpos($String, $Group.":");
   $String1 = substr($String, 0, $Pos);
   $String2 = strstr($String, $Group.":");
   $Lines = explode("\n", $String2);
   $Split = explode(":", $Lines[0]);
   if ($Tipe == "R")
   {
      $Split[3] = $Split[3] - 1;
   }
   else
   {
      $Split[4] = $Split[4] - 1;
   }
   $Lines[0] = implode(":", $Split);
   $String2 = implode("\n", $Lines);
   $String = $String1.$String2;
   ftruncate($FP, 0);
   fputs($FP, $String);
}
// ADDUSER to GADMIN Data file
function addToFile($FP, $File, $Group, $User, $Tipe)
{
   rewind($FP);
   $String = fread($FP, filesize($File));
   $Pos = strpos($String, $Group.":");
   $String1 = substr($String, 0, $Pos);
   $String2 = strstr($String, $Group.":");
   $Split = explode("\n", $String2, 2);
   if ($Tipe == "ratio")
   {
      $Split[0] = $Split[0].":".$User."*R";
   }
   else
   {
      $Split[0] = $Split[0].":".$User."*L";
   }
   $String2 = implode("\n", $Split);
   $String = $String1.$String2;
   ftruncate($FP, 0);
   fputs($FP, $String);
}
// DELUSER from GADMIN Data file
function delFromFile($FP, $File, $Group, $User)
{
   rewind($FP);
   $String = fread($FP, filesize($File));
   $Pos = strpos($String, ":".$User);
   $Bad = ":".$User;
   $String = substr_replace($String, "", $Pos, strlen($Bad));
   ftruncate($FP, 0);
   fputs($FP, $String);
}
// Delay function.
function delay()
{
   for ($i=0; $i<200000; $i++)
   {
      $Crap = 5;
   }
}
// Function that outputs the stored output buffer to client...
function Output($Content)
{
   global $Raidenroot, $GCID, $CMD;

   $Filename = $Raidenroot."/Output/site-".$CMD.".".$GCID;
   $FP = fopen($Filename, "w");
   fwrite($FP, $Content."\n");
   fclose($FP);
}

?>